
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class RecommendationsDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const recommendations = await db.recommendations.create(
            {
                id: data.id || undefined,
        
        score: data.score
        ||
        null
            ,
            
        reason: data.reason
        ||
        null
            ,
            
        generated_at: data.generated_at
        ||
        null
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await recommendations.setUser( data.user || null, {
            transaction,
        });
        
        await recommendations.setSource_title( data.source_title || null, {
            transaction,
        });
        
        await recommendations.setRecommended_title( data.recommended_title || null, {
            transaction,
        });
        

        

        

        return recommendations;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const recommendationsData = data.map((item, index) => ({
                id: item.id || undefined,
                
                score: item.score
            ||
            null
            ,
            
                reason: item.reason
            ||
            null
            ,
            
                generated_at: item.generated_at
            ||
            null
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const recommendations = await db.recommendations.bulkCreate(recommendationsData, { transaction });

        // For each item created, replace relation files
        

        return recommendations;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const recommendations = await db.recommendations.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.score !== undefined) updatePayload.score = data.score;
        
        
        if (data.reason !== undefined) updatePayload.reason = data.reason;
        
        
        if (data.generated_at !== undefined) updatePayload.generated_at = data.generated_at;
        
        
        updatePayload.updatedById = currentUser.id;

        await recommendations.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await recommendations.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        
        if (data.source_title !== undefined) {
            await recommendations.setSource_title(
              
              data.source_title,
              
              { transaction }
            );
        }
        
        if (data.recommended_title !== undefined) {
            await recommendations.setRecommended_title(
              
              data.recommended_title,
              
              { transaction }
            );
        }
        

        
        

        

        return recommendations;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const recommendations = await db.recommendations.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of recommendations) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of recommendations) {
                await record.destroy({transaction});
            }
        });


        return recommendations;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const recommendations = await db.recommendations.findByPk(id, options);

        await recommendations.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await recommendations.destroy({
            transaction
        });

        return recommendations;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const recommendations = await db.recommendations.findOne(
            { where },
            { transaction },
        );

        if (!recommendations) {
            return recommendations;
        }

        const output = recommendations.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await recommendations.getUser({
            transaction
        });
        
        
        output.source_title = await recommendations.getSource_title({
            transaction
        });
        
        
        output.recommended_title = await recommendations.getRecommended_title({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.titles,
        as: 'source_title',
        
        where: filter.source_title ? {
          [Op.or]: [
            { id: { [Op.in]: filter.source_title.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.source_title.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },

      {
        model: db.titles,
        as: 'recommended_title',
        
        where: filter.recommended_title ? {
          [Op.or]: [
            { id: { [Op.in]: filter.recommended_title.split('|').map(term => Utils.uuid(term)) } },
            {
              name: {
                [Op.or]: filter.recommended_title.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            

            
            

            
            if (filter.scoreRange) {
                const [start, end] = filter.scoreRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    score: {
                    ...where.score,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    score: {
                    ...where.score,
                            [Op.lte]: end,
                    },
                };
                }
            }
            
            if (filter.generated_atRange) {
                const [start, end] = filter.generated_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    generated_at: {
                    ...where.generated_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    generated_at: {
                    ...where.generated_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.reason) {
                where = {
                    ...where,
                reason: filter.reason,
            };
            }
            


      

      

      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.recommendations.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'recommendations',
                        'reason',
                        query,
                    ),
                ],
            };
        }

        const records = await db.recommendations.findAll({
            attributes: [ 'id', 'reason' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['reason', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.reason,
        }));
    }

    
};

